package org.jboss.security.propertyeditor;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.security.KeyStore;
import java.security.Principal;
import java.util.Set;
import javax.naming.InitialContext;
import javax.net.ssl.KeyManagerFactory;
import javax.net.ssl.TrustManagerFactory;
import javax.security.auth.Subject;
import org.jboss.security.SecurityDomain;
import org.jboss.security.propertyeditor.SecurityDomainEditor;

class SecurityDomainProxy implements SecurityDomain {
  SecurityDomain delegate;
  
  private String jndiName;
  
  SecurityDomainProxy(String jndiName) {
    this.jndiName = jndiName;
  }
  
  private synchronized void initDelegate() {
    if (this.delegate == null)
      try {
        InitialContext ctx = new InitialContext();
        this.delegate = (SecurityDomain)ctx.lookup(this.jndiName);
      } catch (Exception e) {
        SecurityException se = new SecurityException("Failed to lookup SecurityDomain, " + this.jndiName);
        se.initCause(e);
        throw se;
      }  
  }
  
  public KeyStore getKeyStore() throws SecurityException {
    initDelegate();
    return this.delegate.getKeyStore();
  }
  
  public KeyManagerFactory getKeyManagerFactory() throws SecurityException {
    initDelegate();
    return this.delegate.getKeyManagerFactory();
  }
  
  public KeyStore getTrustStore() throws SecurityException {
    initDelegate();
    return this.delegate.getTrustStore();
  }
  
  public TrustManagerFactory getTrustManagerFactory() throws SecurityException {
    initDelegate();
    return this.delegate.getTrustManagerFactory();
  }
  
  public String getSecurityDomain() {
    initDelegate();
    return this.delegate.getSecurityDomain();
  }
  
  public boolean isValid(Principal principal, Object credential) {
    return isValid(principal, credential, null);
  }
  
  public boolean isValid(Principal principal, Object credential, Subject activeSubject) {
    initDelegate();
    return this.delegate.isValid(principal, credential, activeSubject);
  }
  
  public Subject getActiveSubject() {
    initDelegate();
    return this.delegate.getActiveSubject();
  }
  
  public Principal getPrincipal(Principal principal) {
    initDelegate();
    return this.delegate.getPrincipal(principal);
  }
  
  public boolean doesUserHaveRole(Principal principal, Set roles) {
    initDelegate();
    return this.delegate.doesUserHaveRole(principal, roles);
  }
  
  public Set getUserRoles(Principal principal) {
    initDelegate();
    return this.delegate.getUserRoles(principal);
  }
}
